<?php

namespace Drupal\overview_builder\Annotation;

use Drupal\Component\Annotation\Plugin;

/**
 * Defines an overview builder annotation object.
 *
 * Plugin Namespace: Plugin\OverviewBuilder.
 *
 * @see \Drupal\overview_builder\OverviewBuilderManager
 * @see plugin_api
 *
 * @Annotation
 */
class OverviewBuilder extends Plugin {

  /**
   * The plugin ID.
   *
   * @var string
   */
  public $id;

  /**
   * The Human-readable of the overview builder.
   *
   * @var \Drupal\Core\Annotation\Translation
   *
   * @ingroup plugin_translatable
   */
  public $name;

  /**
   * The entity_type used in the overview builder.
   *
   * @var string
   */
  public $entity_type;

  /**
   * The view_mode used in the overview builder.
   *
   * @var string
   */
  public $view_mode;

}
